//+------------------------------------------------------------------+
//|                                              Color Parabolic.mq5 |
//|                             Copyright  2011,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description "Parabolic Sar"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----       4 
#property indicator_buffers 4
//----  4  
#property indicator_plots   4
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_ARROW
//----       Red
#property indicator_color1  Red
//----   1  1
#property indicator_width1  1
//----   
#property indicator_label1  "Lower Parabolic"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_ARROW
//----       MediumBlue
#property indicator_color2  MediumBlue
//----   2  1
#property indicator_width2  1
//----   
#property indicator_label2 "Upper Parabolic"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   3   
#property indicator_type3   DRAW_ARROW
//----       DeepPink
#property indicator_color3  DeepPink
//----   3  4
#property indicator_width3  4
//----   
#property indicator_label3  "Parabolic Sell"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//----   4   
#property indicator_type4   DRAW_ARROW
//----       BlueViolet
#property indicator_color4  BlueViolet
//----   4  4
#property indicator_width4  4
//----   
#property indicator_label4 "Parabolic Buy"
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET 0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input double Step=0.02;    // 
input double Maximum=0.2;  // 
//+----------------------------------------------+
//----   ,   
//----      
double BuyBuffer[],SellBuffer[];
double UpSarBuffer[],DnSarBuffer[];
//----      
int SAR_Handle;
//----      
int  min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----      
   min_rates_total=2;

//----    iSAR
   SAR_Handle=iSAR(NULL,PERIOD_CURRENT,Step,Maximum);
   if(SAR_Handle==INVALID_HANDLE) Print("      iSAR");

//----    UpSarBuffer[]   
   SetIndexBuffer(0,UpSarBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(0,PLOT_ARROW,158);
//----       
   ArraySetAsSeries(UpSarBuffer,true);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0);

//----    DnSarBuffer[]   
   SetIndexBuffer(1,DnSarBuffer,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(1,PLOT_ARROW,158);
//----       
   ArraySetAsSeries(DnSarBuffer,true);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0);

//----    SellBuffer[]   
   SetIndexBuffer(2,SellBuffer,INDICATOR_DATA);
//----       3
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(2,PLOT_ARROW,174);
//----       
   ArraySetAsSeries(SellBuffer,true);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);

//----    BuyBuffer[]   
   SetIndexBuffer(3,BuyBuffer,INDICATOR_DATA);
//----       4
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(3,PLOT_ARROW,174);
//----       
   ArraySetAsSeries(BuyBuffer,true);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----         
   string short_name="Parabolic Sar";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//----   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(SAR_Handle)<rates_total || rates_total<min_rates_total) return(RESET);
//----    
   int limit,to_copy,bar;
   double SAR[];
//----     
//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-min_rates_total+1; //      
   else limit=rates_total-prev_calculated; //       
   to_copy=limit+2;
//----       SAR
   if(CopyBuffer(SAR_Handle,0,0,to_copy,SAR)<=0) return(RESET);
//----         
   ArraySetAsSeries(SAR,true);
   ArraySetAsSeries(open,true);
//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      //----      
      DnSarBuffer[bar]=0.0;
      UpSarBuffer[bar]=0.0;

      if(open[bar]<SAR[bar]) UpSarBuffer[bar]=SAR[bar];
      else                   DnSarBuffer[bar]=SAR[bar];
     }
//----       
   if(prev_calculated>rates_total || prev_calculated<=0)//           
      limit--;
//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      //----      
      BuyBuffer[bar]=0.0;
      SellBuffer[bar]=0.0;

      if(UpSarBuffer[bar+1]>0.0&&DnSarBuffer[bar]>0.0) BuyBuffer [bar]=SAR[bar];
      if(DnSarBuffer[bar+1]>0.0&&UpSarBuffer[bar]>0.0) SellBuffer[bar]=SAR[bar];
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
